﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Text;
using System.Windows.Input;
using Xamarin.Forms;

namespace SFDataGrid
{
    public class ViewModel : NotificationObject
    {
        private ICommand Clickevent;

        internal OrderInfoRepository order;

        public ViewModel()
        {
            order = new OrderInfoRepository();
            Clickevent = new Command(Clicked);
            SetRowstoGenerate(50);
            ListViewSource = new ObservableCollection<ListViewModel>();
        }
        
        public void Clicked(object a)
        {

        }

        #region ItemsSource

        private ObservableCollection<ListViewModel> listViewSource;
        public ObservableCollection<ListViewModel> ListViewSource
        {
            get { return listViewSource; }
            set
            {
                this.listViewSource = value;
                RaiseCollectionChanged("ListViewSource");
            }
        }


        private ObservableCollection<OrderInfo> ordersInfo;
        public ObservableCollection<OrderInfo> OrdersInfo
        {
            get { return ordersInfo; }
            set
            {
                this.ordersInfo = value;
                RaiseCollectionChanged("OrdersInfo");
            }
        }

        #endregion

        #region ItemSource Generator

        public void SetRowstoGenerate(int count)
        {
            OrdersInfo = order.GenerateOrders();
        }

        #endregion
    }

    public class NotificationObject : INotifyPropertyChanged, INotifyCollectionChanged
    {
        public void RaisePropertyChanged(string propName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaiseCollectionChanged(string propName)
        {
            if (this.CollectionChanged != null)
                this.CollectionChanged(this, new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset));
        }
        public event NotifyCollectionChangedEventHandler CollectionChanged;
    }
}
